HDU 5811 Colosseo

首先判断一下两个集合是否能够拓扑排序,顺便记录下每个节点的拓扑序。

然后看T2中每个点在T1中能够放在哪一个位置,记录下这个位置Pi。

然后T2中(按拓扑序排好),计算Pi的一个非严格递增的LIS。LIS长度就是答案。

这题scanf读入都900+ms了,有时直接卡TLE。改用gets整行读入,时间上会有很大改进。

#pragma comment(linker, "/STACK:1024000000,1024000000")
#include<cstdio>
#include<cstring>
#include<cmath>
#include<algorithm>
#include<vector>
#include<map>
#include<set>
#include<queue>
#include<stack>
#include<iostream>
using namespace std;
typedef long long LL;
const double pi=acos(-1.0),eps=1e-8;
void File()
{
    freopen("D:\\in.txt","r",stdin);
    freopen("D:\\out.txt","w",stdout);
}
inline int read()
{
    char c = getchar(); while(!isdigit(c)) c = getchar(); int x = 0;
    while(isdigit(c)) { x = x * 10 + c - ‘0‘; c = getchar();  }
    return x;
}

const int maxn=1010;
int n,m,g[maxn][maxn],r[maxn],d[maxn],a[maxn],LIS[maxn],dp[maxn];
bool f[maxn];
struct Edge {int u,v,nx;}e[maxn*maxn];
int sz,h[maxn];
char s[3000];

bool Top(int x)
{
    queue<int>Q; sz=0; memset(h,-1,sizeof h); memset(r,0,sizeof r);
    for(int i=1;i<=n;i++) for(int j=1;j<=n;j++)
        if(f[i]==x&&f[j]==x&&g[i][j]==1)
                r[j]++, e[sz].u=i, e[sz].v=j, e[sz].nx=h[i], h[i]=sz++;
    sz=0;
    for(int i=1;i<=n;i++) if(f[i]==x&&r[i]==0) Q.push(i);
    while(!Q.empty())
    {
        int t=Q.front(); Q.pop(); sz++; d[t]=sz;
        for(int i=h[t];i!=-1;i=e[i].nx)
            { r[e[i].v]--; if(r[e[i].v]==0) Q.push(e[i].v); }
    }
    if(x==1) { if(sz!=m) return 0; return 1; }
    else { if(sz!=n-m) return 0; return 1; }
}

int main()
{
    while(~scanf("%d%d",&n,&m))
    {
        getchar(); if(n==0&&m==0) break;
        for(int i=1;i<=n;i++)
        {
            gets(s); int p=0;
            for(int j=1;j<=n;j++) { g[i][j]=s[p]-‘0‘; p=p+2; }
        }
        memset(f,0,sizeof f); for(int i=1;i<=m;i++) {int x; scanf("%d",&x),f[x]=1;}
        bool x1=Top(1), x2=Top(0);
        if(x1==0||x2==0) { printf("NO\n"); continue; }
        for(int i=1;i<=n;i++)
        {
            if(f[i]) continue; int L=m, R=0;
            for(int j=1;j<=n;j++)
            {
                if(!f[j]) continue;
                if(g[i][j]) L=min(L,d[j]-1); else R=max(R,d[j]);
            }
            if(L!=R) a[i]=-1; else a[i]=L;
        }
        memset(LIS,-1,sizeof LIS);
        for(int i=1;i<=n;i++) { if(f[i]) continue; LIS[d[i]]=a[i]; }
        int ans=0; memset(dp,0,sizeof dp);
        for(int i=1;i<=n-m;i++)
        {
            if(LIS[i]==-1) continue;
            int pre=0;  for(int j=1;j<i;j++) if(LIS[j]<=LIS[i]) pre=max(pre,dp[j]);
            dp[i]=pre+1; ans=max(ans,dp[i]);
        }
        printf("YES %d\n",ans);
    }
    return 0;
}
时间: 2024-10-22 02:31:14

HDU 5811 Colosseo的相关文章

【HDU 5811】Colosseo(拓扑+输入优化)

[HDU 5811]Colosseo(拓扑+输入优化) Colosseo Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/65536 K (Java/Others)Total Submission(s): 446    Accepted Submission(s): 98 Problem Description Mr. Chopsticks keeps N monsters, numbered from 1 to N.

HDU 6203 ping ping ping [LCA,贪心,DFS序,BIT(树状数组)]

题目链接:[http://acm.hdu.edu.cn/showproblem.php?pid=6203] 题意 :给出一棵树,如果(a,b)路径上有坏点,那么(a,b)之间不联通,给出一些不联通的点对,然后判断最少有多少个坏点. 题解 :求每个点对的LCA,然后根据LCA的深度排序.从LCA最深的点对开始,如果a或者b点已经有点被标记了,那么continue,否者标记(a,b)LCA的子树每个顶点加1. #include<Bits/stdc++.h> using namespace std;

HDU 5542 The Battle of Chibi dp+树状数组

题目:http://acm.hdu.edu.cn/showproblem.php?pid=5542 题意:给你n个数,求其中上升子序列长度为m的个数 可以考虑用dp[i][j]表示以a[i]结尾的长度为j的上升子序列有多少 裸的dp是o(n2m) 所以需要优化 我们可以发现dp的第3维是找比它小的数,那么就可以用树状数组来找 这样就可以降低复杂度 #include<iostream> #include<cstdio> #include<cstring> #include

hdu 1207 汉诺塔II (DP+递推)

汉诺塔II Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)Total Submission(s): 4529    Accepted Submission(s): 2231 Problem Description 经典的汉诺塔问题经常作为一个递归的经典例题存在.可能有人并不知道汉诺塔问题的典故.汉诺塔来源于印度传说的一个故事,上帝创造世界时作了三根金刚石柱子,在一根柱子上从下往

[hdu 2102]bfs+注意INF

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=2102 感觉这个题非常水,结果一直WA,最后发现居然是0x3f3f3f3f不够大导致的--把INF改成INF+INF就过了. #include<bits/stdc++.h> using namespace std; bool vis[2][15][15]; char s[2][15][15]; const int INF=0x3f3f3f3f; const int fx[]={0,0,1,-1};

HDU 3555 Bomb (数位DP)

数位dp,主要用来解决统计满足某类特殊关系或有某些特点的区间内的数的个数,它是按位来进行计数统计的,可以保存子状态,速度较快.数位dp做多了后,套路基本上都差不多,关键把要保存的状态给抽象出来,保存下来. 简介: 顾名思义,所谓的数位DP就是按照数字的个,十,百,千--位数进行的DP.数位DP的题目有着非常明显的性质: 询问[l,r]的区间内,有多少的数字满足某个性质 做法根据前缀和的思想,求出[0,l-1]和[0,r]中满足性质的数的个数,然后相减即可. 算法核心: 关于数位DP,貌似写法还是

HDU 5917 Instability ramsey定理

http://acm.hdu.edu.cn/showproblem.php?pid=5917 即世界上任意6个人中,总有3个人相互认识,或互相皆不认识. 所以子集 >= 6的一定是合法的. 然后总的子集数目是2^n,减去不合法的,暴力枚举即可. 选了1个肯定不合法,2个也是,3个的话C(n, 3)枚举判断,C(n, 4), C(n, 5) #include <bits/stdc++.h> #define IOS ios::sync_with_stdio(false) using name

hdu 6166 Senior Pan

地址:http://acm.split.hdu.edu.cn/showproblem.php?pid=6166 题目: Senior Pan Time Limit: 12000/6000 MS (Java/Others)    Memory Limit: 131072/131072 K (Java/Others)Total Submission(s): 245    Accepted Submission(s): 71 Problem Description Senior Pan fails i

2017中国大学生程序设计竞赛 - 网络选拔赛 HDU 6155 Subsequence Count 矩阵快速幂

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=6155 题意: 题解来自:http://www.cnblogs.com/iRedBean/p/7398272.html 先考虑dp求01串的不同子序列的个数. dp[i][j]表示用前i个字符组成的以j为结尾的01串个数. 如果第i个字符为0,则dp[i][0] = dp[i-1][1] + dp[i-1][0] + 1,dp[i][1] = dp[i-1][1] 如果第i个字符为1,则dp[i][1